using System;
using System.IO;
using System.Collections;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF05A_CS
	///     lϕsB
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	public delegate double CalcFunc(double x,object o);
	[TestFixture]
	public class C05A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","05A_CS",new Delegate(Main),false);
				return;
			}
			// t@CJ
			StreamReader sr;
			try 
			{
				sr = new StreamReader(args[0]);
				double	d = double.Parse(sr.ReadLine());
				sr.Close();
				if (d > 0) d = 0.5 + Simpson(new CalcFunc(NormDist),0,d,null);
				else d = 0.5 - Simpson(new CalcFunc(NormDist),0,-d,null);
				Console.WriteLine("{0:F5}",d);
			}
			catch (FileNotFoundException e) 
			{
				Console.WriteLine(e.Message);
				return;
			}
		}
		/// <summary>
		/// lower  upper ܂ŁA֐ f 𐔒lϕB
		/// </summary>
		public static double Simpson(CalcFunc f,double lower,double upper,object o)
		{
			double	d,dd, dp = 0, dif = upper - lower, val = 0, pre = 0;
			int		i, cnt = 0, n = 2;
			dd = f(lower,o) + f(upper,o);
			while (++cnt < 16) 
			{
				d = 0;
				for (i=1;i<n;i+=2)
					d += f(lower + dif * i / n,o);
				val = (dd + d * 4 + dp * 2) * dif / 3 / n;
				if (Math.Abs(pre - val) <= 1e-9) break;
				n *= 2;
				pre = val;
				dp += d;
			}
			return val;
		}
		private static double TestFunc(double x,object o) {return 2*x;}
		[Test]
		public void TestSimpson()
		{
			double d = Simpson(new CalcFunc(TestFunc),1,5,null);
			Assertion.AssertEquals("lϕ",d,24);
		}
		/// <summary>
		/// Kz̐ϕp
		/// </summary>
		public static double NormDist(double x,object o)
		{
			return Math.Exp(-x*x/2) / 2.506628274631 /* Math.Sqrt(2*Math.PI) */;
		}
	}
}
