Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports NUnit.Framework

Namespace PSP
    Public Delegate Function Compare(ByVal i As Object, ByVal j As Object, ByVal g As Object) As Boolean
    ''' ۑF08A_VB
    '''     \[g
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    <TestFixture()> _
    Public Class C08A_VB
        Shared Sub Main(ByVal args As String())
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "08A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList = New LinkList()
            Dim i, col As Integer
            If (Not ReadData(args(0), l, col)) Then Return
            Dim a(l.Count - 1) As Object
            Dim d() As Double
            For Each d In l
                a(i) = d
                i += 1
            Next
            Sort(a, AddressOf CompFunc, 0, a.Length, col)
            For Each d In a
                Console.WriteLine("{0} {1} {2}", d(0), d(1), d(2))
            Next
        End Sub
        Public Class Data
            Public ColumnOfCalc As Integer
            <XmlArrayAttribute("ArrayOfArrayOfDouble")> _
            Public list()() As Double
        End Class
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByVal l As LinkList, ByRef col As Integer)
            Dim data As Data
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(Data))
                Dim sr As StreamReader = New StreamReader(fnam)
                data = CType(xr.Deserialize(sr), Data)
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                Return False
            End Try
            Dim d() As Double
            For Each d In data.list
                l.Add(d)
            Next
            col = data.ColumnOfCalc
            Return True
        End Function
        Public Shared Function CompFunc(ByVal i As Object, ByVal j As Object, ByVal g As Object) As Boolean
            Dim d1() As Double = CType(i, Double())
            Dim d2() As Double = CType(j, Double())
            Dim l As Integer = CType(g, Integer)
            Return d1(l) <= d2(l)
        End Function
        ''' }[W\[gB
        Public Shared Sub Sort(ByVal a() As Object, ByVal f As Compare, ByVal i As Integer, ByVal j As Integer, ByVal g As Object)
            If (j - i < 2) Then Return
            Dim h, k, s, t As Integer
            k = (i + j) / 2
            t = k
            Sort(a, f, i, k, g)
            Sort(a, f, k, j, g)
            Dim o(k - i - 1) As Object
            For h = 0 To k - i - 1
                o(h) = a(i + h)
            Next
            For h = i To j - 1
                If (s < k - i AndAlso (t = j OrElse f(o(s), a(t), g))) Then
                    a(h) = o(s)
                    s += 1
                Else
                    a(h) = a(t)
                    t += 1
                End If
            Next
        End Sub
        <Test()> _
        Public Sub TestSort()
            Dim a() As Object = {New Double(){2,1,3}, New Double(){1,2,2}, New Double(){3,3,1}}
            Dim i, j As Integer
            For i=0 To 2
                Sort(a, AddressOf CompFunc, 0, a.Length, i)
                For j=0 To 2
                    Assertion.AssertEquals("Sort", CType(a(j),Double())(i), j+1)
                Next
            Next
        End Sub
    End Class
    ''' NXg
    <TestFixture()> _
    Public Class LinkList
        Implements IEnumerable
        Private Class Enumrt
            Implements IEnumerator
            Private cur As Data
            Private top As Data
            Public Sub New(ByVal d As Data)
                top = d
                Reset()
            End Sub
            Public Sub Reset() Implements IEnumerator.Reset
                cur = top
            End Sub
            Public ReadOnly Property Current() As Object Implements IEnumerator.Current
                Get
                    Return cur.dat
                End Get
            End Property
            Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
                If (cur.nxt Is Nothing) Then Return False
                cur = cur.nxt
                Return True
            End Function
        End Class
        Private Class Data
            Public dat As Object
            Public nxt As Data
            Public Sub New(ByVal o As Object)
                dat = o
                nxt = Nothing
            End Sub
        End Class
        Private n As Integer
        Private dt As Data
        Public Sub New()
            n = 0
            dt = New Data(Nothing)
        End Sub
        Public ReadOnly Property Count() As Integer
            Get
                Return n
            End Get
        End Property
        Public Sub Add(ByVal o As Object)
            Dim p As Data = dt
            While (Not p.nxt Is Nothing)
                p = p.nxt
            End While
            p.nxt = New Data(o)
            n += 1
        End Sub
        Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            Return New Enumrt(dt)
        End Function
        <Test()> _
        Public Sub Test()
            Dim l As LinkList = new LinkList()
            Dim a() As Object = {1,"abc"}
            Dim o As Object
            For Each o In a
               l.Add(o)
            Next
            Dim i As Integer = 0
            For Each o In l
                Assertion.AssertEquals("vf̊mF",o,a(i))
                i += 1
            Next
        End Sub
    End Class
End Namespace

