using System;
using System.IO;

namespace PSP
{
	public delegate void Delegate(string[] args);
	/// <summary>
	/// u_test_v܂ޑSt@CeXgAʂ result.txt ɏo͂܂B
	/// </summary>
	public class CAllTest
	{
		public static void Check(string user,string prob,Delegate dg,bool bShow)
		{
			string[] fs = Directory.GetFiles("../prob/case/", prob + "_test_*.xml");
			if (fs.Length == 0) 
			{
				fs = Directory.GetFiles("../prob/case/", prob + "_test_*.txt");
			}
			if (fs.Length == 0) 
			{
					Console.WriteLine("eXgP[X܂");
				return;
			}
			string	res = "res.tmp";
			try 
			{
				int		nOk = 0;
				foreach (string fin in fs) 
				{
					string[]	ss = {fin};
					string		fout = fin;
					fout = fout.Replace("xml","txt");
					fout = fout.Replace("test","result");
					StreamWriter	sw = new StreamWriter(res);
					if (!bShow) Console.SetOut(sw);
					dg(ss);
					sw.Close();
					if (!CheckOne(fout,res)) 
					{
						Console.Error.WriteLine("Error {0}",fin);
						continue;
					} 
					++nOk;
				}
				StreamWriter	swr = new StreamWriter("result.txt",false,System.Text.Encoding.Default);
				int		k = 100*nOk/fs.Length;
				swr.WriteLine("{0} {1} {2}",user,prob,k);
				swr.Close();
				Console.Error.WriteLine("{0} {1} {2}",user,prob,k);
				if (k == 100) Console.Error.WriteLine("S{0}eXg OK !",nOk);
				File.Delete(res);
			} 
			catch (Exception e) 
			{
				Console.Error.WriteLine(e.Message);
			}
		}
		public static bool CheckOne(string fnam1,string fnam2)
		{
			StreamReader	sr1 = null;
			StreamReader	sr2 = null;
			try 
			{
				sr1 = new StreamReader(fnam1,System.Text.Encoding.Default);
				sr2 = new StreamReader(fnam2);
				string	s1,s2;
				while ((s1 = sr1.ReadLine()) != null) 
				{
					if ((s2 = sr2.ReadLine()) == null)
						return false;
					if (!s1.Equals(s2))
						return false;
				}
				if ((s2 = sr2.ReadLine()) != null)
					return false;
			}
			catch (Exception)
			{
				return false;
			}
			finally 
			{
				if (sr1 != null) sr1.Close();
				if (sr2 != null) sr2.Close();
			}
			return true;
		}
	}
}
