Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports NUnit.Framework

Namespace PSP
    ''' ۑF01A_VB
    '''     ςƕW΍
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    <TestFixture()> _
    Public Class C01A_VB
       Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "01A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList
            If (Not ReadData(args(0), l)) Then Return
            Dim ave, std As Double
            Calc(l, ave, std)
            Console.WriteLine("{0:F2} {1:F5}", ave, std)
        End Sub
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByRef l As LinkList)
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(LinkList))
                Dim sr As StreamReader = New StreamReader(fnam)
                l = CType(xr.Deserialize(sr), LinkList)
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                l = Nothing
                Return False
            End Try
            Return True
        End Function
        ''' ςƕW΍vZ܂B
        Public Shared Sub Calc(ByVal l As LinkList, ByRef ave As Double, ByRef std As Double)
            ave = 0
            std = 0
            Dim d As Double
            For Each d In l
                ave += d
                std += d * d
            Next
            ave /= Math.Max(1, l.Count)
            std = Math.Sqrt((std - ave * ave * l.Count) / Math.Max(1, l.Count - 1))
        End Sub
        <Test()> _
        Public Sub TestCalc()
            Dim l As LinkList = New LinkList()
            Dim ave, std As Double
            Calc(l, ave, std)
            Assertion.AssertEquals("vf1̕",ave,0.0,0.0)
            Assertion.AssertEquals("vf1̕W΍",std,0.0,0.0)
            l.Add(123.4)
            Calc(l, ave, std)
            Assertion.AssertEquals("vf2̕",ave,123.4,0.0)
            Assertion.AssertEquals("vf2̕W΍",std,0.0,0.0)
            l.Add(125.4)
            l.Add(136.4)
            Calc(l, ave, std)
            Assertion.AssertEquals("vf3̕",ave,128.4,0.0)
            Assertion.AssertEquals("vf3̕W΍",std,7.0,0.0)
        End Sub
    End Class
    ''' NXg
    <TestFixture()> _
    Public Class LinkList
        Implements IEnumerable
        Private Class Enumrt
            Implements IEnumerator
            Private cur As Data
            Private top As Data
            Public Sub New(ByVal d As Data)
                top = d
                Reset()
            End Sub
            Public Sub Reset() Implements IEnumerator.Reset
                cur = top
            End Sub
            Public ReadOnly Property Current() As Object Implements IEnumerator.Current
                Get
                    Return cur.dat
                End Get
            End Property
            Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
                If (cur.nxt Is Nothing) Then Return False
                cur = cur.nxt
                Return True
            End Function
        End Class
        Private Class Data
            Public dat As Object
            Public nxt As Data
            Public Sub New(ByVal o As Object)
                dat = o
                nxt = Nothing
            End Sub
        End Class
        Private n As Integer
        Private dt As Data
        Public Sub New()
            n = 0
            dt = New Data(Nothing)
        End Sub
        Public ReadOnly Property Count() As Integer
            Get
                Return n
            End Get
        End Property
        Public Sub Add(ByVal o As Object)
            Dim p As Data = dt
            While (Not p.nxt Is Nothing)
                p = p.nxt
            End While
            p.nxt = New Data(o)
            n += 1
        End Sub
        Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            Return New Enumrt(dt)
        End Function
        <Test()> _
        Public Sub Test()
            Dim l As LinkList = new LinkList()
            Dim a() As Object = {1,"abc"}
            Dim o As Object
            For Each o In a
               l.Add(o)
            Next
            Dim i As Integer = 0
            For Each o In l
                Assertion.AssertEquals("vf̊mF",o,a(i))
                i += 1
            Next
        End Sub
    End Class
End Namespace
