using System;
using System.IO;
using System.Collections;
using NUnit.Framework;

namespace PSP
{
	/// <summary>
	/// ۑF02A_CS
	///     LOC ̃JEg
	/// 쐬Ftsutomu
	/// PSPStudy o[WF1.03
	/// </summary>
	[TestFixture]
	public class C02A_CS
	{
		/// <summary>
		/// 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
		/// 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if (args.Length == 0)	// Sf[^ŃeXg
			{
				Directory.SetCurrentDirectory("../..");
				CAllTest.Check("tsutomu","02A_CS",new Delegate(Main),false);
				return;
			}
			int loc = CalcLoc(args[0]);
			Console.WriteLine(loc);
		}
		/// <summary>
		/// t@CǂLOCԂ܂B
		/// </summary>
		public static int CalcLoc(string fnam)
		{
			// t@CJ
			StreamReader sr;
			try 
			{
				sr = new StreamReader(fnam);
			}
			catch (FileNotFoundException e) 
			{
				Console.WriteLine(e.Message);
				return -1;
			}
			int	c,cc, loc = 0;
			while ((c = sr.Read()) >= 0) 
			{
				if (c == '\\') 
				{
					sr.Read();
				}
				else if (c == '\'' || c == '"') 
				{
					while ((cc = sr.Read()) >= 0)
						if (cc == '\\') sr.Read();
						else if (cc == c) break;
				} 
				else if (c == ';' || c == '{') 
				{
					++loc;
				}
				if (c != '/') continue;
				c = sr.Peek();
				if (c == '/') 
				{
					while ((c = sr.Read()) >= 0)
						if (c == '\n') break;
				} 
				else if (c == '*') 
				{
					sr.Read();
					do 
					{
						while ((c = sr.Read()) >= 0)
							if (c == '*') break;
					} while (c >= 0 && sr.Peek() != '/');
					sr.Read();
				}
			}
			sr.Close();
			return loc;
		}
		[Test]
		public void TestCalcLoc()
		{
			string fnam = "testCase.txt";
			StreamWriter sw;
			sw = new StreamWriter(fnam);
			sw.WriteLine("';'=0 \";;\"=0 '\\'';;;;=4 \"\\\"\"{{{{{{{{=8");
			sw.Close();
			Assertion.AssertEquals("ƕ",CalcLoc(fnam),12);
			sw = new StreamWriter(fnam);
			sw.WriteLine("/* **/;=1 //*{{=0");
			sw.WriteLine(";;;;=4 /*;;;;;;;;=0");
			sw.WriteLine(";;;;;;;;;;;;;;;;=0 */ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;=32");
			sw.Close();
			Assertion.AssertEquals("Rg",CalcLoc(fnam),37);
			File.Delete(fnam);
		}
	}
}
