Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports NUnit.Framework

Namespace PSP
    ''' ۑF04A_VB
    '''     `Aɂ\
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    <TestFixture()> _
    Public Class C04A_VB
        Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "04A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList
            If (Not ReadData(args(0), l)) Then Return
            Dim sumx, sumy, b0, b1 As Double
            Calc(l, sumx, sumy, b0, b1)
            Console.WriteLine("{0:F5} {1:F5}", b0, b1)
        End Sub
        <Test()> _
        Public Sub Test()
            Dim l As LinkList = new LinkList()
            Dim sumx, sumy, b0, b1 As Double
            Calc(l, sumx, sumy, b0, b1)
            Assertion.AssertEquals("vf̊mF", sumx, 0)
            Assertion.AssertEquals("vf̊mF", sumy, 0)
            Assertion.AssertEquals("vf̊mF", b0, 0)
            Assertion.AssertEquals("vf̊mF", b1, 0)
            l.Add(New Double(){1, 123.4})
            Calc(l, sumx, sumy, b0, b1)
            Assertion.AssertEquals("vf̊mF", b0, 123.4)
            Assertion.AssertEquals("vf̊mF", b1, 0)
            l.Add(New Double(){2, 223.4})
            Calc(l, sumx, sumy, b0, b1)
            Assertion.AssertEquals("vf̊mF", b0, 23.4)
            Assertion.AssertEquals("vf̊mF", b1, 100)
        End Sub
        ''' t@Cf[^Ǎ݂܂B
        Public Shared Function ReadData(ByVal fnam As String, ByRef l As LinkList)
            Try ' t@CJ
                Dim xr As XmlSerializer = New XmlSerializer(GetType(LinkList), New Type(){GetType(Double())})
                Dim sr As StreamReader = New StreamReader(fnam)
                l = CType(xr.Deserialize(sr), LinkList)
                sr.Close()
            Catch e As FileNotFoundException
                Console.Error.WriteLine(e.Message)
                l = Nothing
                Return False
            End Try
            Return True
        End Function
        ''' 0A1vZ܂B
        Public Shared Sub Calc(ByVal l As LinkList, ByRef sumx As Double, ByRef sumy As Double, _
                ByRef b0 As Double, ByRef b1 As Double)
            Dim sumxx, sumxy As Double
            sumx = 0
            sumy = 0
            b0 = 0
            b1 = 0
            Dim d() As Double
            For Each d In l
                sumx += d(0)
                sumy += d(1)
                sumxx += d(0) * d(0)
                sumxy += d(0) * d(1)
            Next
            If (l.Count > 0) Then sumx /= l.Count
            If (l.Count > 0) Then sumy /= l.Count
            b1 = sumxx - l.Count * sumx * sumx
            If (b1 <> 0) Then b1 = (sumxy - l.Count * sumx * sumy) / b1
            b0 = sumy - b1 * sumx
        End Sub
    End Class
    ''' NXg
    <TestFixture()> _
    Public Class LinkList
        Implements IEnumerable
        Private Class Enumrt
            Implements IEnumerator
            Private cur As Data
            Private top As Data
            Public Sub New(ByVal d As Data)
                top = d
                Reset()
            End Sub
            Public Sub Reset() Implements IEnumerator.Reset
                cur = top
            End Sub
            Public ReadOnly Property Current() As Object Implements IEnumerator.Current
                Get
                    Return cur.dat
                End Get
            End Property
            Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
                If (cur.nxt Is Nothing) Then Return False
                cur = cur.nxt
                Return True
            End Function
        End Class
        Private Class Data
            Public dat As Object
            Public nxt As Data
            Public Sub New(ByVal o As Object)
                dat = o
                nxt = Nothing
            End Sub
        End Class
        Private n As Integer
        Private dt As Data
        Public Sub New()
            n = 0
            dt = New Data(Nothing)
        End Sub
        Public ReadOnly Property Count() As Integer
            Get
                Return n
            End Get
        End Property
        Public Sub Add(ByVal o As Object)
            Dim p As Data = dt
            While (Not p.nxt Is Nothing)
                p = p.nxt
            End While
            p.nxt = New Data(o)
            n += 1
        End Sub
        Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            Return New Enumrt(dt)
        End Function
        <Test()> _
        Public Sub Test()
            Dim l As LinkList = new LinkList()
            Dim a() As Object = {1,"abc"}
            Dim o As Object
            For Each o In a
               l.Add(o)
            Next
            Dim i As Integer = 0
            For Each o In l
                Assertion.AssertEquals("vf̊mF",o,a(i))
                i += 1
            Next
        End Sub
    End Class
End Namespace

