Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports NUnit.Framework

Namespace PSP
    ''' ۑF07A_VB
    '''     ֌WƗLӐ̔
    ''' 쐬Ftsutomu
    ''' PSPStudy o[WF1.03
    <TestFixture()> _
    Public Class C07A_VB
        ''' 0̏ꍇASeXgsAʂ result.txt ɏo͂܂B
        ''' 1ȏ̏ꍇAt@Cf[^ǂŌʂWo͂ɏo͂܂B
        Shared Sub Main(ByVal args() As String)
            If (args.Length = 0) Then ' Sf[^ŃeXg
                Directory.SetCurrentDirectory("..")
                AllTest.Check("tsutomu", "07A_VB", AddressOf Main, False)
                Exit Sub
            End If
            Dim l As LinkList
            If (Not C04A_VB.ReadData(args(0), l)) Then Return
            If (l.Count <= 2) Then Return
            Dim r, t, p As Double
            Calc(l, r, t)
            p = GFunc(t, l.Count - 2)
            Console.WriteLine("r = {0:F4}" + vbCrLf + "t = {1:F4}" + vbCrLf + "2(1-p) = {2:E2}", r, t, 2 * (1 - p))
        End Sub
        ''' ֌WvZ܂B
        Public Shared Sub Calc(ByVal l As LinkList, ByRef r As Double, ByRef t As Double)
            Dim dd, d(), sumx, sumy, sumxx, sumxy, sumyy As Double
            sumx = 0
            sumy = 0
            sumxx = 0
            sumyy = 0
            sumxy = 0
            For Each d In l
                sumx += d(0)
                sumy += d(1)
                sumxx += d(0) * d(0)
                sumxy += d(0) * d(1)
                sumyy += d(1) * d(1)
            Next
            dd = Math.Sqrt((l.Count * sumxx - sumx * sumx) * (l.Count * sumyy - sumy * sumy))
            If (dd = 0) Then dd = 1
            r = (l.Count * sumxy - sumx * sumy) / dd
            dd = 1 - r * r
            If (dd = 0) Then dd = 1
            t = Math.Abs(r) * Math.Sqrt((l.Count - 2) / dd)
        End Sub
        <Test()> _
        Public Sub TestCalc()
			Dim l As LinkList = new LinkList()
			Dim r, t As Double
			l.Add(new double(){1,2})
			l.Add(new double(){2,1})
			l.Add(new double(){3,3})
			Calc(l, r, t)
			Assertion.AssertEquals("֌Wr", r, 0.5)
			Assertion.AssertEquals("֌Wt", t, Math.Sqrt(1/3.0))
        End Sub
        Public Shared Function FuncT(ByVal x As Double, ByVal o As Object) As Double
            Dim n As Integer = CType(o, Integer)
            Return Math.Pow(1 + x * x / n, -(n + 1) / 2.0)
        End Function
        Public Shared Function GFunc(ByVal x As Double, ByVal n As Integer) As Double
            Return 0.5 + Math.Exp(lngamma((n + 1) / 2.0) - lngamma(n / 2.0)) / Math.Sqrt(n * Math.PI) _
                * C05A_VB.Simpson(AddressOf FuncT, 0, x, n)
        End Function
        ''' (x) = Math.Exp(lngamma(x))
        Public Shared Function lngamma(ByVal xx As Double) As Double
            Dim cof() As Double = {76.18009173, -86.50532033, 24.01409822, _
             -1.231739516, 0.00120858003, -0.00000536382}
            Dim x As Double = xx - 1.0
            Dim tmp As Double = x + 5.5
            tmp -= (x + 0.5) * Math.Log(tmp)
            Dim ser As Double = 1.0
            Dim j As Integer
            For j = 0 To 5
                x += 1.0
                ser += cof(j) / x
            Next
            Return -tmp + Math.Log(2.50662827465 * ser)
        End Function
    End Class
End Namespace
